/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#ifdef __GNUG__
#pragma implementation "listx_tmpl.hxx"
#pragma implementation "dictx_tmpl.hxx"
#pragma implementation "smartp_tmpl.hxx"
#pragma implementation "c++_const.hxx"
#pragma implementation "dictionary_tmpl.hxx"
#pragma implementation "dbvue_clnt.hxx"
#pragma implementation "callbackclient_clnt.hxx"
#pragma implementation "callbackserver_clnt.hxx"
#pragma implementation "iter_tmpl.hxx"
#endif

#include "yoo_root.hxx"
#include "dictionary.hxx"
#include "listln.hxx"
#include "col.hxx"
#include "dict.hxx"

template class Iterator<ADM_SchFile> ;
template class Iterator<ObjectX> ;
template class Iterator<ADM_Clu> ;
template class Iterator<ADM_Vol> ;
template class Iterator<ADM_Class> ;
template class Iterator<ADM_NameObj> ;
template class Iterator<ADM_Server> ;
template class Iterator<ADM_Col> ;

template class LocalListX<ADM_SchFile> ;
template class LocalListX<ObjectX> ;
template class LocalListX<ADM_Clu> ;
template class LocalListX<ADM_Vol> ;
template class LocalListX<ADM_Class> ;
template class LocalListX<ADM_NameObj> ;
template class LocalListX<ADM_Server> ;
template class LocalListX<ADM_Col> ;

template class ListX<ADM_SchFile> ;
template class ListX<ObjectX> ;
template class ListX<ADM_Clu> ;
template class ListX<ADM_Vol> ;
template class ListX<ADM_Class> ;
template class ListX<ADM_NameObj> ;
template class ListX<ADM_Server> ;

template class DictX<ADM_Vol, StringX, yoo_index(ADM_Vol::name)> ;
template class DictX<ADM_Clu, StringX, yoo_index(ADM_Clu::name)> ;
template class DictX<ADM_Class, StringX, yoo_index(ADM_Class::name)> ;
template class DictX<ADM_NameObj, StringX, yoo_index(ADM_NameObj::name)> ;
template class DictX<ADM_SchFile, StringX, yoo_index(ADM_SchFile::name)> ;
template class DictX<ADM_Server, StringX, yoo_index(ADM_Server::name)> ;

extern void (*YOO_TabRefresh[]) (void *) ;
void yoo_refreshInit() {
 //0 reserved for non C++ objects
 YOO_TabRefresh[3] = ListNode::yoo_refresh ;
 YOO_TabRefresh[4] = ListLeaf::yoo_refresh ;
 YOO_TabRefresh[5] = DictNode::yoo_refresh ;
 YOO_TabRefresh[6] = DictLeaf::yoo_refresh ;

 YoodaDictionary.setOid(OID(YOO_ADMIN_VOL, YOO_FIRST_USED_PAGE, 3)) ;
} ;

void (*YOO_TabRefresh[7]) (void*) ;
int YOO_LastClassId = 7 ;
Ref<ADM_Admin> YoodaDictionary ;


